﻿using FLY.OBJComponents.Client;
using FLY.Weight.Client;
using FLY.Weight.IService;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Unity;

namespace FLY.Weight.UI.Client
{
    /// <summary>
    /// Page_Thickness.xaml 的交互逻辑
    /// </summary>
    public partial class PgThickness : Page
    {
        IWeightSystemService weightSystemService;
        SetPLCUpdatePlan setPlan_accessory;

        public PgThickness()
        {
            InitializeComponent();

        }


        [InjectionMethod]
        public void Init(IWeightSystemService weightSystemService)
        {
            this.weightSystemService = weightSystemService;
            root_grid.DataContext = this.weightSystemService;

            RebuildPlans();
        }

        /// <summary>
        /// 由于数量改变，重新构造更新计划
        /// </summary>
        void RebuildPlans()
        {
            string objname = nameof(IWeightSystemService.Accessory);
            setPlan_accessory = new SetPLCUpdatePlan(
                    weightSystemService.PLCos,
                    objname,
                    new string[] {
                        nameof(Common.WeighterAccessory.WheelPerimeter),
                        nameof(Common.WeighterAccessory.WheelPulse),
                        nameof(Common.WeighterAccessory.Density)
                    });
            
        }

        private void button_back_Click(object sender, RoutedEventArgs e)
        {
            setPlan_accessory.Dispose();
            NavigationService.GoBack();
        }
    }
}
