﻿using FLY.ControlLibrary;
using FLY.OBJComponents.Client;
using FLY.OBJComponents.IService;
using FLY.Weight.Client;
using FLY.Weight.Common;
using FLY.Weight.IService;
using FLY.Weight.Server.Model;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Unity;

namespace FLY.Weight.UI.Client
{
    /// <summary>
    /// Window_RatioSet.xaml 的交互逻辑
    /// </summary>
    public partial class WdIngredient : WindowBigClose
    {
        IUnityContainer container;
        IWeightSystemService weightSystemService;
        WeighterC weight;
        SetPLCUpdatePlan setPlan;

        public WdIngredient()
        {
            InitializeComponent();
        }

        [InjectionMethod]
        public void Init(
            IUnityContainer container,
            WeighterC weight,
            IWeightSystemService weightSystemService)
        {
            this.container = container;
            this.weightSystemService = weightSystemService;
            this.weight = weight;
            this.grid_weighter.DataContext = weight;

            List<string> props = new List<string>();
            props.Add(nameof(WeighterC.MixSet));
            props.Add(nameof(WeighterC.MixBucketWeight));
            props.Add(nameof(WeighterC.CumulativeProduction));

            for (int j = 0; j < weight.BinCnt; j++)
            {
                int no = j + 1;
                props.Add($"{nameof(IngredientCell.MixLight)}_{no}");
                //props.Add("MixPSet_" + no);
                //props.Add("MixPDisp_" + no);
                props.Add($"{nameof(IngredientCell.MixCumPercent)}_{no}");

                //props.Add("MixSet_" + no);
                //props.Add("MixDisp_" + no);
                props.Add($"{nameof(IngredientCell.MixCum)}_{no}");
            }
            int index = this.weightSystemService.Items.IndexOf(weight);
            string objname = $"{nameof(IWeightSystemService.Items)}[{index}]";
            setPlan = new SetPLCUpdatePlan(
                this.weightSystemService.PLCos,
                objname,
                props);
        }

        private void button_clear_Click(object sender, RoutedEventArgs e)
        {
            this.weight.ClearProduction = true;
        }
        private void button_mix_Click(object sender, RoutedEventArgs e)
        {
            this.Close();


            WeighterC w = weight;

            PgMixTable p = new PgMixTable();
            container.BuildUp(p,
                new Unity.Resolution.ParameterOverride("w", w));


            MultiLayout.FlyLayoutManager.NavigationService.Navigate(p);            
        }

        private void button_rollmix_Click(object sender, RoutedEventArgs e)
        {
            this.Close();


            WeighterC w = weight;

            PgRollMixTable p = new PgRollMixTable();
            container.BuildUp(p,
                new Unity.Resolution.ParameterOverride("w", w));


            MultiLayout.FlyLayoutManager.NavigationService.Navigate(p);
        }

        private void WindowBigClose_Unloaded(object sender, RoutedEventArgs e)
        {
            setPlan.Dispose();
        }
    }

}
